<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Formatters/HTML/Fragments/HeadingFormatter.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Formatters/HTML/Fragments/HeadingFormatter.py</title>
<link href="../../../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Formatters/HTML/Fragments/HeadingFormatter.py</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stephen Davies</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stefan Seefeld</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line7"></a><span class="lineno">  7</span><span class="line"><span class="py-comment">#</span></span>
<a id="line8"></a><span class="lineno">  8</span>
<a id="line9"></a><span class="lineno">  9</span><span class="line"><span class="py-keyword">from</span> Synopsis <span class="py-keyword">import</span> ASG</span>
<a id="line10"></a><span class="lineno"> 10</span><span class="line"><span class="py-keyword">from</span> Synopsis.Formatters.HTML.Fragment <span class="py-keyword">import</span> Fragment</span>
<a id="line11"></a><span class="lineno"> 11</span><span class="line"><span class="py-keyword">from</span> Synopsis.Formatters.HTML.Tags <span class="py-keyword">import</span> *</span>
<a id="line12"></a><span class="lineno"> 12</span><span class="line"><span class="py-keyword">from</span> SourceLinker <span class="py-keyword">import</span> SourceLinker</span>
<a id="line13"></a><span class="lineno"> 13</span><span class="line"><span class="py-keyword">from</span> XRefLinker <span class="py-keyword">import</span> XRefLinker</span>
<a id="line14"></a><span class="lineno"> 14</span>
<a id="line15"></a><span class="lineno"> 15</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Fragments/HeadingFormatter/HeadingFormatter.html">HeadingFormatter</a>(Fragment):</span>
<a id="line16"></a><span class="lineno"> 16</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Formats the top of a view - it is passed only the Declaration that the</span></span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line"><span class="py-string">    view is for (a Module or Class).&quot;&quot;&quot;</span></span>
<a id="line18"></a><span class="lineno"> 18</span>
<a id="line19"></a><span class="lineno"> 19</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Fragments/HeadingFormatter/HeadingFormatter.html#register">register</a>(self, formatter):</span>
<a id="line20"></a><span class="lineno"> 20</span>
<a id="line21"></a><span class="lineno"> 21</span><span class="line">        super(HeadingFormatter, self).register(formatter)</span>
<a id="line22"></a><span class="lineno"> 22</span><span class="line">        <span class="py-keyword">if</span> self.processor.has_view(<span class="py-string">'XRef'</span>):</span>
<a id="line23"></a><span class="lineno"> 23</span><span class="line">            self.xref = XRefLinker()</span>
<a id="line24"></a><span class="lineno"> 24</span><span class="line">            self.xref.register(formatter)</span>
<a id="line25"></a><span class="lineno"> 25</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line26"></a><span class="lineno"> 26</span><span class="line">            self.xref = None</span>
<a id="line27"></a><span class="lineno"> 27</span><span class="line">        <span class="py-keyword">if</span> self.processor.has_view(<span class="py-string">'Source'</span>):</span>
<a id="line28"></a><span class="lineno"> 28</span><span class="line">            self.source = SourceLinker()</span>
<a id="line29"></a><span class="lineno"> 29</span><span class="line">            self.source.register(formatter)</span>
<a id="line30"></a><span class="lineno"> 30</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line31"></a><span class="lineno"> 31</span><span class="line">            self.source = None</span>
<a id="line32"></a><span class="lineno"> 32</span>
<a id="line33"></a><span class="lineno"> 33</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Fragments/HeadingFormatter/HeadingFormatter.html#format_name">format_name</a>(self, qname):</span>
<a id="line34"></a><span class="lineno"> 34</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Formats a qualified name such that each name component becomes a link</span></span>
<a id="line35"></a><span class="lineno"> 35</span><span class="line"><span class="py-string">        to the respective scope.&quot;&quot;&quot;</span></span>
<a id="line36"></a><span class="lineno"> 36</span>
<a id="line37"></a><span class="lineno"> 37</span><span class="line">        scope, text = type(qname)(), []</span>
<a id="line38"></a><span class="lineno"> 38</span><span class="line">        <span class="py-keyword">for</span> name <span class="py-keyword">in</span> qname[:-1]:</span>
<a id="line39"></a><span class="lineno"> 39</span><span class="line">            scope = scope + (name,)</span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line">            text.append(self.reference(scope))</span>
<a id="line41"></a><span class="lineno"> 41</span><span class="line">        text.append(escape(qname[-1]))</span>
<a id="line42"></a><span class="lineno"> 42</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">'%s\n'</span>%(qname.sep).join(text) + <span class="py-string">'\n'</span></span>
<a id="line43"></a><span class="lineno"> 43</span>
<a id="line44"></a><span class="lineno"> 44</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Fragments/HeadingFormatter/HeadingFormatter.html#format_name_in_module">format_name_in_module</a>(self, qname):</span>
<a id="line45"></a><span class="lineno"> 45</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Formats a reference to each parent scope, starting at the first</span></span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line"><span class="py-string">        non-module scope.&quot;&quot;&quot;</span></span>
<a id="line47"></a><span class="lineno"> 47</span>
<a id="line48"></a><span class="lineno"> 48</span><span class="line">        types = self.processor.ir.asg.types</span>
<a id="line49"></a><span class="lineno"> 49</span>
<a id="line50"></a><span class="lineno"> 50</span><span class="line">        scope, text = type(qname)(), []</span>
<a id="line51"></a><span class="lineno"> 51</span><span class="line">        <span class="py-keyword">for</span> name <span class="py-keyword">in</span> qname[:-1]:</span>
<a id="line52"></a><span class="lineno"> 52</span><span class="line">            scope += (name,)</span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line">            <span class="py-keyword">if</span> types.has_key(scope):</span>
<a id="line54"></a><span class="lineno"> 54</span><span class="line">                ns_type = types[scope]</span>
<a id="line55"></a><span class="lineno"> 55</span><span class="line">                <span class="py-keyword">if</span> isinstance(ns_type, ASG.DeclaredTypeId):</span>
<a id="line56"></a><span class="lineno"> 56</span><span class="line">                    decl = ns_type.declaration</span>
<a id="line57"></a><span class="lineno"> 57</span><span class="line">                    <span class="py-keyword">if</span> isinstance(decl, ASG.Module):</span>
<a id="line58"></a><span class="lineno"> 58</span><span class="line">                        <span class="py-comment"># Skip modules</span></span>
<a id="line59"></a><span class="lineno"> 59</span><span class="line">                        <span class="py-keyword">continue</span></span>
<a id="line60"></a><span class="lineno"> 60</span><span class="line">            text.append(self.reference(scope))</span>
<a id="line61"></a><span class="lineno"> 61</span><span class="line">        text.append(escape(qname[-1]))</span>
<a id="line62"></a><span class="lineno"> 62</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">'%s\n'</span>%qname.sep.join(text) + <span class="py-string">'\n'</span></span>
<a id="line63"></a><span class="lineno"> 63</span>
<a id="line64"></a><span class="lineno"> 64</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Fragments/HeadingFormatter/HeadingFormatter.html#format_module_of_name">format_module_of_name</a>(self, qname):</span>
<a id="line65"></a><span class="lineno"> 65</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Formats a reference to each parent scope and this one.&quot;&quot;&quot;</span></span>
<a id="line66"></a><span class="lineno"> 66</span>
<a id="line67"></a><span class="lineno"> 67</span><span class="line">        types = self.processor.ir.asg.types</span>
<a id="line68"></a><span class="lineno"> 68</span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line">        scope, text = type(qname)(), []</span>
<a id="line70"></a><span class="lineno"> 70</span><span class="line">        last_decl = None</span>
<a id="line71"></a><span class="lineno"> 71</span><span class="line">        <span class="py-keyword">for</span> name <span class="py-keyword">in</span> qname:</span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line">            scope += (name,)</span>
<a id="line73"></a><span class="lineno"> 73</span><span class="line">            <span class="py-keyword">if</span> types.has_key(scope):</span>
<a id="line74"></a><span class="lineno"> 74</span><span class="line">                ns_type = types[scope]</span>
<a id="line75"></a><span class="lineno"> 75</span><span class="line">                <span class="py-keyword">if</span> isinstance(ns_type, ASG.DeclaredTypeId):</span>
<a id="line76"></a><span class="lineno"> 76</span><span class="line">                    decl = ns_type.declaration</span>
<a id="line77"></a><span class="lineno"> 77</span><span class="line">                    <span class="py-keyword">if</span> isinstance(decl, ASG.Module):</span>
<a id="line78"></a><span class="lineno"> 78</span><span class="line">                        <span class="py-comment"># Only do modules</span></span>
<a id="line79"></a><span class="lineno"> 79</span><span class="line">                        text.append(self.reference(scope))</span>
<a id="line80"></a><span class="lineno"> 80</span><span class="line">                        last_decl = decl</span>
<a id="line81"></a><span class="lineno"> 81</span><span class="line">                        <span class="py-keyword">continue</span></span>
<a id="line82"></a><span class="lineno"> 82</span><span class="line">            <span class="py-keyword">break</span></span>
<a id="line83"></a><span class="lineno"> 83</span><span class="line">        <span class="py-keyword">return</span> last_decl, qname.sep.join(text) + <span class="py-string">'\n'</span></span>
<a id="line84"></a><span class="lineno"> 84</span>
<a id="line85"></a><span class="lineno"> 85</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Fragments/HeadingFormatter/HeadingFormatter.html#format_module">format_module</a>(self, module):</span>
<a id="line86"></a><span class="lineno"> 86</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Formats the module by linking to each parent scope in the name.&quot;&quot;&quot;</span></span>
<a id="line87"></a><span class="lineno"> 87</span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line">        <span class="py-comment"># Module details are only printed at the top of their view</span></span>
<a id="line89"></a><span class="lineno"> 89</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> module.name:</span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line">            title = <span class="py-string">'Global %s'</span>%module.type.capitalize()</span>
<a id="line91"></a><span class="lineno"> 91</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line92"></a><span class="lineno"> 92</span><span class="line">            title = <span class="py-string">'%s %s'</span>%(module.type.capitalize(), self.format_name(module.name))</span>
<a id="line93"></a><span class="lineno"> 93</span><span class="line">        <span class="py-keyword">return</span> element(<span class="py-string">'h1'</span>, title)</span>
<a id="line94"></a><span class="lineno"> 94</span>
<a id="line95"></a><span class="lineno"> 95</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Fragments/HeadingFormatter/HeadingFormatter.html#format_meta_module">format_meta_module</a>(self, module):</span>
<a id="line96"></a><span class="lineno"> 96</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Calls format_module.&quot;&quot;&quot;</span></span>
<a id="line97"></a><span class="lineno"> 97</span>
<a id="line98"></a><span class="lineno"> 98</span><span class="line">        <span class="py-keyword">return</span> self.format_module(module)</span>
<a id="line99"></a><span class="lineno"> 99</span>
<a id="line100"></a><span class="lineno">100</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Fragments/HeadingFormatter/HeadingFormatter.html#format_class">format_class</a>(self, class_):</span>
<a id="line101"></a><span class="lineno">101</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Formats the class by linking to each parent scope in the name.&quot;&quot;&quot;</span></span>
<a id="line102"></a><span class="lineno">102</span>
<a id="line103"></a><span class="lineno">103</span><span class="line">        <span class="py-comment"># Calculate the module string</span></span>
<a id="line104"></a><span class="lineno">104</span><span class="line">        decl, module = self.format_module_of_name(class_.name)</span>
<a id="line105"></a><span class="lineno">105</span><span class="line">        <span class="py-keyword">if</span> decl:</span>
<a id="line106"></a><span class="lineno">106</span><span class="line">            module = <span class="py-string">'%s %s'</span>%(decl.type, module)</span>
<a id="line107"></a><span class="lineno">107</span><span class="line">            module = div(<span class="py-string">'class-module'</span>, module)</span>
<a id="line108"></a><span class="lineno">108</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line109"></a><span class="lineno">109</span><span class="line">            module = <span class="py-string">''</span></span>
<a id="line110"></a><span class="lineno">110</span>
<a id="line111"></a><span class="lineno">111</span><span class="line">        <span class="py-comment"># Calculate class name string</span></span>
<a id="line112"></a><span class="lineno">112</span><span class="line">        type = class_.type</span>
<a id="line113"></a><span class="lineno">113</span><span class="line">        name = self.format_name_in_module(class_.name)</span>
<a id="line114"></a><span class="lineno">114</span><span class="line">        name = div(<span class="py-string">'class-name'</span>, <span class="py-string">'%s %s'</span>%(type, name))</span>
<a id="line115"></a><span class="lineno">115</span>
<a id="line116"></a><span class="lineno">116</span><span class="line">        <span class="py-comment"># Calculate file-related string</span></span>
<a id="line117"></a><span class="lineno">117</span><span class="line">        file_name = rel(self.processor.output, class_.file.name)</span>
<a id="line118"></a><span class="lineno">118</span><span class="line">        <span class="py-comment"># Try the file index view first</span></span>
<a id="line119"></a><span class="lineno">119</span><span class="line">        file_link = self.directory_layout.file_index(class_.file.name)</span>
<a id="line120"></a><span class="lineno">120</span><span class="line">        <span class="py-keyword">if</span> self.processor.filename_info(file_link):</span>
<a id="line121"></a><span class="lineno">121</span><span class="line">            file_ref = href(rel(self.formatter.filename(), file_link), file_name, target=<span class="py-string">'detail'</span>)</span>
<a id="line122"></a><span class="lineno">122</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line123"></a><span class="lineno">123</span><span class="line">            <span class="py-comment"># Try source file next</span></span>
<a id="line124"></a><span class="lineno">124</span><span class="line">            file_link = self.directory_layout.file_source(class_.file.name)</span>
<a id="line125"></a><span class="lineno">125</span><span class="line">            <span class="py-keyword">if</span> self.processor.filename_info(file_link):</span>
<a id="line126"></a><span class="lineno">126</span><span class="line">                file_ref = href(rel(self.formatter.filename(), file_link), file_name)</span>
<a id="line127"></a><span class="lineno">127</span><span class="line">            <span class="py-keyword">else</span>:</span>
<a id="line128"></a><span class="lineno">128</span><span class="line">                file_ref = file_name</span>
<a id="line129"></a><span class="lineno">129</span>
<a id="line130"></a><span class="lineno">130</span><span class="line">        links = div(<span class="py-string">'file'</span>, <span class="py-string">'File: %s'</span>%file_ref)</span>
<a id="line131"></a><span class="lineno">131</span><span class="line">        <span class="py-keyword">if</span> self.xref: links += <span class="py-string">' %s'</span>%div(<span class="py-string">'xref'</span>, self.xref.format_class(class_))</span>
<a id="line132"></a><span class="lineno">132</span><span class="line">        <span class="py-keyword">if</span> self.source: links += <span class="py-string">' %s'</span>%div(<span class="py-string">'source'</span>, self.source.format_class(class_))</span>
<a id="line133"></a><span class="lineno">133</span><span class="line">        info = div(<span class="py-string">'links'</span>, links)</span>
<a id="line134"></a><span class="lineno">134</span>
<a id="line135"></a><span class="lineno">135</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">'%s%s%s'</span>%(module, name, info)</span>
<a id="line136"></a><span class="lineno">136</span>
<a id="line137"></a><span class="lineno">137</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Fragments/HeadingFormatter/HeadingFormatter.html#format_class_template">format_class_template</a>(self, class_):</span>
<a id="line138"></a><span class="lineno">138</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Formats the class template by linking to each parent scope in the name.&quot;&quot;&quot;</span></span>
<a id="line139"></a><span class="lineno">139</span>
<a id="line140"></a><span class="lineno">140</span><span class="line">        <span class="py-comment"># Calculate the module string</span></span>
<a id="line141"></a><span class="lineno">141</span><span class="line">        decl, module = self.format_module_of_name(class_.name)</span>
<a id="line142"></a><span class="lineno">142</span><span class="line">        <span class="py-keyword">if</span> decl:</span>
<a id="line143"></a><span class="lineno">143</span><span class="line">            module = <span class="py-string">'%s %s'</span>%(decl.type, module)</span>
<a id="line144"></a><span class="lineno">144</span><span class="line">            module = div(<span class="py-string">'class-module'</span>, module)</span>
<a id="line145"></a><span class="lineno">145</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line146"></a><span class="lineno">146</span><span class="line">            module = <span class="py-string">''</span></span>
<a id="line147"></a><span class="lineno">147</span>
<a id="line148"></a><span class="lineno">148</span><span class="line">        <span class="py-comment"># Calculate template string</span></span>
<a id="line149"></a><span class="lineno">149</span><span class="line">        templ = class_.template</span>
<a id="line150"></a><span class="lineno">150</span><span class="line">        params = templ.parameters</span>
<a id="line151"></a><span class="lineno">151</span><span class="line">        params = <span class="py-string">', '</span>.join([self.format_parameter(p) <span class="py-keyword">for</span> p <span class="py-keyword">in</span> params])</span>
<a id="line152"></a><span class="lineno">152</span><span class="line">        templ = div(<span class="py-string">'class-template'</span>, <span class="py-string">&quot;template &amp;lt;%s&amp;gt;&quot;</span>%params)</span>
<a id="line153"></a><span class="lineno">153</span>
<a id="line154"></a><span class="lineno">154</span><span class="line">        <span class="py-comment"># Calculate class name string</span></span>
<a id="line155"></a><span class="lineno">155</span><span class="line">        type = class_.type</span>
<a id="line156"></a><span class="lineno">156</span><span class="line">        name = self.format_name_in_module(class_.name)</span>
<a id="line157"></a><span class="lineno">157</span><span class="line">        name = div(<span class="py-string">'class-name'</span>, <span class="py-string">'%s %s'</span>%(type, name))</span>
<a id="line158"></a><span class="lineno">158</span>
<a id="line159"></a><span class="lineno">159</span><span class="line">        <span class="py-comment"># Calculate file-related string</span></span>
<a id="line160"></a><span class="lineno">160</span><span class="line">        file_name = rel(self.processor.output, class_.file.name)</span>
<a id="line161"></a><span class="lineno">161</span><span class="line">        <span class="py-comment"># Try the file index view first</span></span>
<a id="line162"></a><span class="lineno">162</span><span class="line">        file_link = self.directory_layout.file_index(class_.file.name)</span>
<a id="line163"></a><span class="lineno">163</span><span class="line">        <span class="py-keyword">if</span> self.processor.filename_info(file_link):</span>
<a id="line164"></a><span class="lineno">164</span><span class="line">            file_ref = href(rel(self.formatter.filename(), file_link), file_name, target=<span class="py-string">'detail'</span>)</span>
<a id="line165"></a><span class="lineno">165</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line166"></a><span class="lineno">166</span><span class="line">            <span class="py-comment"># Try source file next</span></span>
<a id="line167"></a><span class="lineno">167</span><span class="line">            file_link = self.directory_layout.file_source(class_.file.name)</span>
<a id="line168"></a><span class="lineno">168</span><span class="line">            <span class="py-keyword">if</span> self.processor.filename_info(file_link):</span>
<a id="line169"></a><span class="lineno">169</span><span class="line">                file_ref = href(rel(self.formatter.filename(), file_link), file_name)</span>
<a id="line170"></a><span class="lineno">170</span><span class="line">            <span class="py-keyword">else</span>:</span>
<a id="line171"></a><span class="lineno">171</span><span class="line">                file_ref = file_name</span>
<a id="line172"></a><span class="lineno">172</span>
<a id="line173"></a><span class="lineno">173</span><span class="line">        links = div(<span class="py-string">'file'</span>, <span class="py-string">'File: %s'</span>%file_ref)</span>
<a id="line174"></a><span class="lineno">174</span><span class="line">        <span class="py-keyword">if</span> self.xref: links += <span class="py-string">' %s'</span>%div(<span class="py-string">'xref'</span>, self.xref.format_class(class_))</span>
<a id="line175"></a><span class="lineno">175</span><span class="line">        <span class="py-keyword">if</span> self.source: links += <span class="py-string">' %s'</span>%div(<span class="py-string">'source'</span>, self.source.format_class(class_))</span>
<a id="line176"></a><span class="lineno">176</span><span class="line">        info = div(<span class="py-string">'links'</span>, links)</span>
<a id="line177"></a><span class="lineno">177</span>
<a id="line178"></a><span class="lineno">178</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">'%s%s%s%s'</span>%(module, templ, name, info)</span>
<a id="line179"></a><span class="lineno">179</span>
<a id="line180"></a><span class="lineno">180</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Fragments/HeadingFormatter/HeadingFormatter.html#format_forward">format_forward</a>(self, forward):</span>
<a id="line181"></a><span class="lineno">181</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Formats the forward declaration if it is a template declaration.&quot;&quot;&quot;</span></span>
<a id="line182"></a><span class="lineno">182</span>
<a id="line183"></a><span class="lineno">183</span><span class="line">        <span class="py-comment"># Calculate the module string</span></span>
<a id="line184"></a><span class="lineno">184</span><span class="line">        decl, module = self.format_module_of_name(forward.name)</span>
<a id="line185"></a><span class="lineno">185</span><span class="line">        <span class="py-keyword">if</span> decl:</span>
<a id="line186"></a><span class="lineno">186</span><span class="line">            module = <span class="py-string">'%s %s'</span>%(decl.type, module)</span>
<a id="line187"></a><span class="lineno">187</span><span class="line">            module = div(<span class="py-string">'class-module'</span>, module)</span>
<a id="line188"></a><span class="lineno">188</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line189"></a><span class="lineno">189</span><span class="line">            module = <span class="py-string">''</span></span>
<a id="line190"></a><span class="lineno">190</span>
<a id="line191"></a><span class="lineno">191</span><span class="line">        <span class="py-comment"># Calculate template string</span></span>
<a id="line192"></a><span class="lineno">192</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> forward.template:</span>
<a id="line193"></a><span class="lineno">193</span><span class="line">            <span class="py-keyword">return</span> <span class="py-string">''</span></span>
<a id="line194"></a><span class="lineno">194</span>
<a id="line195"></a><span class="lineno">195</span><span class="line">        params = forward.template.parameters</span>
<a id="line196"></a><span class="lineno">196</span><span class="line">        params = <span class="py-string">', '</span>.join([self.format_parameter(p) <span class="py-keyword">for</span> p <span class="py-keyword">in</span> params])</span>
<a id="line197"></a><span class="lineno">197</span><span class="line">        templ = div(<span class="py-string">'class-template'</span>, <span class="py-string">&quot;template &amp;lt;%s&amp;gt;&quot;</span>%params)</span>
<a id="line198"></a><span class="lineno">198</span>
<a id="line199"></a><span class="lineno">199</span><span class="line">        <span class="py-comment"># Calculate class name string</span></span>
<a id="line200"></a><span class="lineno">200</span><span class="line">        type = forward.type</span>
<a id="line201"></a><span class="lineno">201</span><span class="line">        name = self.format_name_in_module(forward.name)</span>
<a id="line202"></a><span class="lineno">202</span><span class="line">        name = div(<span class="py-string">'class-name'</span>, <span class="py-string">'%s %s'</span>%(type, name))</span>
<a id="line203"></a><span class="lineno">203</span>
<a id="line204"></a><span class="lineno">204</span><span class="line">        <span class="py-comment"># Calculate file-related string</span></span>
<a id="line205"></a><span class="lineno">205</span><span class="line">        file_name = rel(self.processor.output, forward.file.name)</span>
<a id="line206"></a><span class="lineno">206</span><span class="line">        <span class="py-comment"># Try the file index view first</span></span>
<a id="line207"></a><span class="lineno">207</span><span class="line">        file_link = self.directory_layout.file_index(forward.file.name)</span>
<a id="line208"></a><span class="lineno">208</span><span class="line">        <span class="py-keyword">if</span> self.processor.filename_info(file_link):</span>
<a id="line209"></a><span class="lineno">209</span><span class="line">            file_ref = href(rel(self.formatter.filename(), file_link), file_name, target=<span class="py-string">'detail'</span>)</span>
<a id="line210"></a><span class="lineno">210</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line211"></a><span class="lineno">211</span><span class="line">            <span class="py-comment"># Try source file next</span></span>
<a id="line212"></a><span class="lineno">212</span><span class="line">            file_link = self.directory_layout.file_source(forward.file.name)</span>
<a id="line213"></a><span class="lineno">213</span><span class="line">            <span class="py-keyword">if</span> self.processor.filename_info(file_link):</span>
<a id="line214"></a><span class="lineno">214</span><span class="line">                file_ref = href(rel(self.formatter.filename(), file_link), file_name)</span>
<a id="line215"></a><span class="lineno">215</span><span class="line">            <span class="py-keyword">else</span>:</span>
<a id="line216"></a><span class="lineno">216</span><span class="line">                file_ref = file_name</span>
<a id="line217"></a><span class="lineno">217</span>
<a id="line218"></a><span class="lineno">218</span><span class="line">        links = div(<span class="py-string">'file'</span>, <span class="py-string">'File: %s'</span>%file_ref)</span>
<a id="line219"></a><span class="lineno">219</span><span class="line">        info = div(<span class="py-string">'links'</span>, links)</span>
<a id="line220"></a><span class="lineno">220</span>
<a id="line221"></a><span class="lineno">221</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">'%s%s%s%s'</span>%(module, templ, name, info)</span>
<a id="line222"></a><span class="lineno">222</span>
<a id="line223"></a><span class="lineno">223</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Fragments/HeadingFormatter/HeadingFormatter.html#format_parameter">format_parameter</a>(self, parameter):</span>
<a id="line224"></a><span class="lineno">224</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Returns one string for the given parameter&quot;&quot;&quot;</span></span>
<a id="line225"></a><span class="lineno">225</span>
<a id="line226"></a><span class="lineno">226</span><span class="line">        chunks = []</span>
<a id="line227"></a><span class="lineno">227</span><span class="line">        <span class="py-comment"># Premodifiers</span></span>
<a id="line228"></a><span class="lineno">228</span><span class="line">        chunks.extend([span(<span class="py-string">&quot;keyword&quot;</span>, escape(m)) <span class="py-keyword">for</span> m <span class="py-keyword">in</span> parameter.premodifier])</span>
<a id="line229"></a><span class="lineno">229</span><span class="line">        <span class="py-comment"># Param Type</span></span>
<a id="line230"></a><span class="lineno">230</span><span class="line">        typestr = self.format_type(parameter.type)</span>
<a id="line231"></a><span class="lineno">231</span><span class="line">        <span class="py-keyword">if</span> typestr: chunks.append(typestr)</span>
<a id="line232"></a><span class="lineno">232</span><span class="line">        <span class="py-comment"># Postmodifiers</span></span>
<a id="line233"></a><span class="lineno">233</span><span class="line">        chunks.extend([span(<span class="py-string">&quot;keyword&quot;</span>, m) <span class="py-keyword">for</span> m <span class="py-keyword">in</span> parameter.postmodifier])</span>
<a id="line234"></a><span class="lineno">234</span><span class="line">        <span class="py-comment"># Param name</span></span>
<a id="line235"></a><span class="lineno">235</span><span class="line">        <span class="py-keyword">if</span> len(parameter.name) != 0:</span>
<a id="line236"></a><span class="lineno">236</span><span class="line">            chunks.append(span(<span class="py-string">&quot;variable&quot;</span>, parameter.name))</span>
<a id="line237"></a><span class="lineno">237</span><span class="line">        <span class="py-comment"># Param value</span></span>
<a id="line238"></a><span class="lineno">238</span><span class="line">        <span class="py-keyword">if</span> len(parameter.value) != 0:</span>
<a id="line239"></a><span class="lineno">239</span><span class="line">            chunks.append(<span class="py-string">&quot; = &quot;</span> + span(<span class="py-string">&quot;value&quot;</span>, parameter.value))</span>
<a id="line240"></a><span class="lineno">240</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">' '</span>.join(chunks)</span>
<a id="line241"></a><span class="lineno">241</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:12 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
